{% extends "base.html" %}
{% block static %}
  {% load static %}
  <link rel="stylesheet" type="text/css" href="{% static 'style/admin_users/dashboard.css' %}">
  <link rel="stylesheet" type="text/css" href="{% static 'style/app.css' %}">
{% endblock %}
{% block title %}Strapper - Admin{% endblock %}
{% block content %}
  <main>
    <div>
      <!-- Admin dashboard navbar -->
      <ul class="nav nav-tabs" id="adminDashboardTab" role="tablist">
        <li class="nav-item" role="presentation">
          <button class="nav-link {% if not active_tab %}active{% endif %}" data-bs-toggle="tab" data-bs-target="#general-config-tab-pane" type="button" role="tab" aria-controls="general-config-tab-pane" aria-selected="true">General</button>
        </li>
        <li class="nav-item" role="presentation">
          <button class="nav-link {% if active_tab == 'database' %}active{% endif %}" data-bs-toggle="tab" data-bs-target="#database-tab-pane" type="button" role="tab" aria-controls="database-tab-pane" aria-selected="true">Databases</button>
        </li>
        <li class="nav-item" role="presentation">
          <button class="nav-link {% if active_tab == 'keycloak' %}active{% endif %}" data-bs-toggle="tab" data-bs-target="#keycloak-tab-pane" type="button" role="tab" aria-controls="keycloak-tab-pane" aria-selected="true">Authentication</button>
        </li>
        <li class="nav-item" role="presentation">
          <button class="nav-link {% if active_tab == 'harbor' %}active{% endif %}" data-bs-toggle="tab" data-bs-target="#harbor-tab-pane" type="button" role="tab" aria-controls="harbor-tab-pane" aria-selected="true">Registry</button>
        </li>
        <li class="nav-item" role="presentation">
          <button class="nav-link {% if active_tab == 'object_storage' %}active{% endif %}" data-bs-toggle="tab" data-bs-target="#object-storage-tab-pane" type="button" role="tab" aria-controls="object-storage-tab-pane" aria-selected="true">Object Storage</button>
        </li>
        <li class="nav-item" role="presentation">
          <button class="nav-link {% if active_tab == 'k8s' %}active{% endif %} {% if pending_k8s_resource_requests|length > 0 %}text-danger fw-bolder{% endif %}" data-bs-toggle="tab" data-bs-target="#k8s-tab-pane" type="button" role="tab" aria-controls="k8s-tab-pane" aria-selected="true">
            K8s {% if pending_k8s_resource_requests|length > 0 %}<i class="fa-solid fa-exclamation ms-1"></i>{% endif %}
          </button>
        </li>
      </ul>

      <!-- Admin dashboard content -->
      <div class="tab-content tab-display" id="adminDashboardContent">

        <!-- General config tab -->
        <div class="tab-pane fade {% if not active_tab %}show active{% endif %}" id="general-config-tab-pane" role="tabpanel" aria-labelledby="general-config-tab-pane" tabindex="0">
          {% include 'admin_users/components/general_configs.html' %}
        </div>
        <!-- End general config tab -->

        <!-- Databases tab -->
        <div class="tab-pane fade {% if active_tab == 'database' %}show active{% endif %}" id="database-tab-pane" role="tabpanel" aria-labelledby="database-tab-pane" tabindex="0">

          <!-- PostgreSQL -->
          {% with database_config=database_config_psql %}
            {% include 'admin_users/components/database.html' %}
          {% endwith %}

          <!-- MySQL -->
          <div class="mt-4">
            {% with database_config=database_config_mysql %}
              {% include 'admin_users/components/database.html' %}
            {% endwith %}
          </div>

        </div>
        <!-- End database tab -->

        <!-- Keycloak tab -->
        <div class="tab-pane fade {% if active_tab == 'keycloak' %}show active{% endif %}" id="keycloak-tab-pane" role="tabpanel" aria-labelledby="keycloak-tab-pane" tabindex="0">
          {% include 'admin_users/components/authentication.html' %}
        </div>
        <!-- End Keycloak tab -->

        <!-- Registry tab -->
        <div class="tab-pane fade {% if active_tab == 'harbor' %}show active{% endif %}" id="harbor-tab-pane" role="tabpanel" aria-labelledby="harbor-tab-pane" tabindex="0">
          {% include 'admin_users/components/registry.html' %}
        </div>
        <!-- End registry tab -->

        <!-- Object storage tab -->
        <!-- An object storage has the following field: bucket (str), region (str), endpoint URL (str), access key (str), secret key (str) -->
        <div class="tab-pane fade {% if active_tab == 'object_storage' %}show active{% endif %}" id="object-storage-tab-pane" role="tabpanel" aria-labelledby="object-storage-tab-pane" tabindex="0">

          <!-- Object storage for STRAP -->
          {% with object_storage_config=object_storage_config_strap %}
            {% include 'admin_users/components/object_storage.html' %}
          {% endwith %}
          <!-- End object storage for STRAP -->

          <!-- Object storage for STRAP applications -->
          <div class="mt-4">
            {% with object_storage_config=object_storage_config_strapplications %}
              {% include 'admin_users/components/object_storage.html' %}
            {% endwith %}
          </div>
          <!-- End object storage for STRAP applications -->

        </div>
        <!-- End object storage tab -->

        <!-- K8s tab -->
        <!-- Include an URL to the K8s server, client key and a client certificate -->
        <div class="tab-pane fade {% if active_tab == 'k8s' %}show active{% endif %}" id="k8s-tab-pane" role="tabpanel" aria-labelledby="k8s-tab-pane" tabindex="0">
          <!-- K8s configs -->
          {% include 'admin_users/components/k8s.html' %}

          <!-- Pending K8s resource requests -->
          <div class="mt-3">
            {% include 'admin_users/components/k8s_resource_requests.html' %}
          </div>
        </div>
        <!-- End K8s tab -->

      </div>
    </div>
  </main>

  <!-- K8s resource request process modal -->
  {% include 'admin_users/modals/k8s_resource_request.html' %}
{% endblock %}
{% block script %}
  {% load static %}
  <script src="{% static 'js/admin_users/dashboard.js' %}" type="module"></script>
{% endblock %}
